#ifndef __CHATTAB_H
#define __CHATTAB_H

#include <qtabwidget.h>
#include <qmap.h>
#include "channel.h"

class ChatTab: public QTabWidget
{
	Q_OBJECT
	public slots:
		void slotClearCurrent();
	private:
		typedef QMap<QString, Channel *> ChannelMap;
		ChannelMap cmap;
		Channel *currentPage() { return (Channel *)QTabWidget::currentPage(); }
	public:
		ChatTab(QWidget *parent);
		~ChatTab();
		bool isPrivate(const QString &name);
		bool isPrivate() { return isPrivate(current()); }
		bool addChannel(const QString &name, const QString &topic);
		bool delChannel(const QString &name);
		bool addPrivate(const QString &name);
		bool delPrivate(const QString &name);
		QString getTopic(const QString &name);
		bool setTopic(const QString &name, const QString &topic);
		bool write(const QString &channel, const QString &str, QColor color);
		bool exists(const QString &name) { return cmap.contains(name); }
		QString current() { return currentPage()->name(); }
		QString channelsList();
};

#endif

