#include "msgwin.h"
#include <qlayout.h>

MessageSndWindow::MessageSndWindow(const QString &to): QWidget(NULL)/*{{{*/
{
	this->to = to;
	
	setWFlags(Qt::WDestructiveClose | getWFlags());
	setCaption(QString("Message to: ") + to);
	QBoxLayout *l1 = new QVBoxLayout(this);
	msg = new QTextEdit(this);
	msg->setTextFormat(PlainText);
	l1->addWidget(msg);
	
	QBoxLayout *bl = new QHBoxLayout(l1);
	b_send = new QPushButton("Send", this);
	b_ok = new QPushButton("OK", this);
	bl->addWidget(b_send);
	bl->addStretch(20);
	bl->addWidget(b_ok);
	
	setMinimumSize(280, 120);

	connect(b_send, SIGNAL(clicked()), this, SLOT(slotSendButton()));
	connect(b_ok, SIGNAL(clicked()), this, SLOT(close()));
}/*}}}*/

MessageSndWindow::~MessageSndWindow()/*{{{*/
{
	//cout << "deleted" << endl;
}/*}}}*/

MessageRcvWindow::MessageRcvWindow(const QString &from, const QString &str): QWidget(NULL)/*{{{*/
{
	this->from = from;
	
	setWFlags(Qt::WDestructiveClose | getWFlags());
	setCaption(QString("Message from: ") + from);
	QBoxLayout *l1 = new QVBoxLayout(this);
	msg = new QTextEdit(this);
	rpl = new QTextEdit(this);
	msg->setReadOnly(true);
	msg->setTextFormat(PlainText);
	rpl->setTextFormat(PlainText);
	l1->addWidget(msg);
	l1->addWidget(rpl);
	msg->append(str);
	
	QBoxLayout *bl = new QHBoxLayout(l1);
	b_reply = new QPushButton("Send reply", this);
	b_ok = new QPushButton("OK", this);
	bl->addWidget(b_reply);
	bl->addStretch(20);
	bl->addWidget(b_ok);
	
	setMinimumSize(280, 200);

	connect(b_reply, SIGNAL(clicked()), this, SLOT(slotReplyButton()));
	connect(b_ok, SIGNAL(clicked()), this, SLOT(close()));
}/*}}}*/

MessageRcvWindow::~MessageRcvWindow()/*{{{*/
{
	//cout << "deleted" << endl;
}/*}}}*/

/*-----------------------------------------------------------------------------------------------------
 * 
 *                                            S L O T S
 *
 -----------------------------------------------------------------------------------------------------*/
void MessageSndWindow::slotSendButton()/*{{{*/
{
	emit send(to, msg->text());
	close();
}/*}}}*/

void MessageRcvWindow::slotReplyButton()/*{{{*/
{
	emit reply(from, rpl->text());
	close();
}/*}}}*/

