#ifndef __MSGWIN_H
#define __MSGWIN_H

#include <qtextedit.h>
#include <qpushbutton.h>


class MessageSndWindow: public QWidget
{
	Q_OBJECT
	private slots:
		void slotSendButton();
	signals:
		void send(const QString &nick, const QString &str);
	private:
		QString to;
		QTextEdit *msg;
		QPushButton *b_ok, *b_send;
	public:
		MessageSndWindow(const QString &to);
		virtual ~MessageSndWindow();

};

class MessageRcvWindow: public QWidget
{
	Q_OBJECT
	private slots:
		void slotReplyButton();
	signals:
		void reply(const QString &nick, const QString &str);
	private:
		QString from;
		QTextEdit *msg, *rpl;
		QPushButton *b_ok, *b_reply;
	public:
		MessageRcvWindow(const QString &from, const QString &msg);
		virtual ~MessageRcvWindow();
};

#endif

