#include "regexp.h"
#include "history.h"
#include <qlayout.h>

RegexpWin::RegexpWin(QWidget *parent, const History &hist, bool on): QDialog(parent, NULL, true)/*{{{*/
{
	setCaption("Regexp matching");
	
	infolist = new QComboBox(true, this);
	infolist->setMinimumWidth(240);
	infolist->setMaxCount(10);
	infolist->insertStringList(hist.l);
	
	b_ok = new QPushButton("OK", this);
	b_enable = new QCheckBox("Enable", this);
	b_enable->setChecked(on);
	
	QBoxLayout *l1 = new QHBoxLayout(this);
	l1->addWidget(infolist);
	l1->addWidget(b_enable);
	l1->addStretch(20);
	l1->addWidget(b_ok);
	connect(b_ok, SIGNAL(clicked()), this, SLOT(accept()));
}/*}}}*/

RegexpWin::~RegexpWin()/*{{{*/
{
}/*}}}*/

void RegexpWin::accept()/*{{{*/
{
	emit changeRegexp(infolist->currentText(), b_enable->isChecked());
	QDialog::accept();
}/*}}}*/

