#ifndef __SETTINGS_H
#define __SETTINGS_H

#include "sound.h"
#include <qsettings.h>
#include <qdialog.h>
#include <qlineedit.h>
#include <qspinbox.h>
#include <qvbuttongroup.h>

class Settings
{
	private:
		QString nick, def_nick;
		QString hostname, def_hostname;
		QString ip, def_ip;
		QString broadcast, def_broadcast;
		QString topic, def_topic;
		Sound::SoundType def_sound;
		int refresh;
		bool hide_channels;
		QColor special_color;
		QColor normal_color;
		QColor own_color;
		int x, y, width, height;
		Sound::SoundType sound;
		QString snd_chatline, def_snd_chatline;
		QString snd_beep, def_snd_beep;
		QString snd_message, def_snd_message;
		QString snd_join, def_snd_join;
		QString snd_leave, def_snd_leave;
		QString snd_regexp, def_snd_regexp;
		bool regexp_on;
	public:
		Settings();
		~Settings();
		bool getDefaults();
		void load();
		void save();
	
		friend class MainWindow;
		friend class SettingsDialog;
		friend class Sound;
};

class SettingsDialog: public QDialog
{
	Q_OBJECT
	private slots:
		void slotApply();
		void slotDefaults();
	private:
		QLineEdit *le_nick, *le_hostname, *le_ip, *le_broadcast;
		QSpinBox *sp_refresh;
		QVButtonGroup *opt_snddev;
		Settings *settings;
	public:
		SettingsDialog(QWidget *parent, Settings *settings);
		~SettingsDialog();
};

#endif

