#ifndef __SOUND_H
#define __SOUND_H

#include <qstring.h>
#include <qmemarray.h>

class Settings;

class Sound
{	
	public:
		enum SoundType { NoSound=0, PCSpeaker, Arts, Esd };
		enum Sfx { Chatline=0, JoinChannel, LeaveChannel, Beep, Message, RegexMatch };
	private:
		static QString errstr;
		static SoundType sndtype;
		static QByteArray sample[];
		static bool load_sample(Sfx sfx, const QString &filename);
	public:
		static bool init(Settings *settings);
		static void close();
		static const QString& Sound::error() { return errstr; }
		static void play(Sfx sfx);
};

#endif

