#include "vysocket.h"
#include "vypacket.h"
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/socket.h>
//#include <iostream.h>
#include <iostream>
using std::cerr;
using std::cout;
using std::endl;

#include <assert.h>

VyGetSocket::VyGetSocket(): QSocketDevice(QSocketDevice::Datagram)/*{{{*/
{
	QHostAddress ip;
	if (ip.setAddress("0.0.0.0"))
	{
		setBlocking(FALSE);
		if (!bind(ip, VY_PORT))
		{
			cerr << "error: cannont bind to socket" << endl;
		}
	}
	else
	{
		cerr << "error: cannot set IP address" << endl;
	}
}/*}}}*/

VyGetSocket::~VyGetSocket()/*{{{*/
{
}/*}}}*/

VySendSocket::VySendSocket(const QString &addr): QSocketDevice(QSocketDevice::Datagram)/*{{{*/
{
	if (broadcast.setAddress(addr))
	{	
		setBlocking(FALSE);
		int opt = 1;
		setsockopt(socket(), SOL_SOCKET, SO_BROADCAST, &opt, sizeof(int)); 
		//if (!bind(broadcast, 8166))
		//{
		//	perror("bind: ");
		//}
	}
	else
	{
		cerr << "error setting IP address" << endl;
	}
	pdata = new char [VY_MAXPACKETSIZE+1];
	*pdata = 'X';
	plen = 0;
	srandom(time(NULL));
}/*}}}*/

VySendSocket::~VySendSocket()/*{{{*/
{
	delete pdata;
}/*}}}*/

void VySendSocket::send(const QHostAddress &addr, const char *format, ...)/*{{{*/
{
	va_list arg;
	va_start(arg, format);
	plen = 0;
	//
	// packet id
	for (int i=1; i<11; i++)
		pdata[i] = 0x20 + random()%95;
	//
	// the rest of the packet
	plen = vsprintf(pdata+10, format, arg);
	va_end(arg);
	plen += 11;
	//
	// send it to the network
	int went = writeBlock(pdata, plen, addr, VY_PORT);
	if (went != plen)
		cerr << "shit, socket overfull..." << endl;
}/*}}}*/

void VySendSocket::vy_say(const QString &channel, const QString &nick, const QString &text)/*{{{*/
{
	send(broadcast, "%c%s%c%s%c%s%c", VY_SAY, channel.latin1(), 0, nick.latin1(), 0, text.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_me(const QString &channel, const QString &nick, const QString &text)/*{{{*/
{
	send(broadcast, "%c%s%c%s%c%s%c", VY_ME, channel.latin1(), 0, nick.latin1(), 0, text.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_whohere(const QString &updater)/*{{{*/
{
	send(broadcast, "%c%s%c", VY_WHOHERE, updater.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_imhere(const QString &updater, const QString &responder, char status, char winstate)/*{{{*/
{
	send(broadcast, "%c%s%c%s%c%c%c", VY_IMHERE, updater.latin1(), 0, responder.latin1(), 0, status, winstate);
}/*}}}*/

void VySendSocket::vy_beep(const QHostAddress &addr, const QString& to, const QString& from)/*{{{*/
{
	send(addr, "%c%c%s%c%s%c", VY_BEEP, VY_BEEP_SIGNAL, to.latin1(), 0, from.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_beepack(const QHostAddress &addr, const QString& to, const QString& from, char gender)/*{{{*/
{
	send(addr, "%c%c%s%c%s%c%c", VY_BEEP, VY_BEEP_ACK, from.latin1(), 0, to.latin1(), 0, gender);
}/*}}}*/

void VySendSocket::vy_join(const QString &who, const QString &channel, char status, char gender)/*{{{*/
{
	send(broadcast, "%c%s%c%s%c%c%c", VY_JOIN, who.latin1(), 0, channel.latin1(), 0, status, gender);
}/*}}}*/

void VySendSocket::vy_leave(const QString &who, const QString &channel, char gender)/*{{{*/
{
	send(broadcast, "%c%s%c%s%c%c", VY_LEAVE, who.latin1(), 0, channel.latin1(), 0, gender);
}/*}}}*/

void VySendSocket::vy_private_join(const QHostAddress &addr, const QString &from, const QString &to, char gender)/*{{{*/
{
	send(addr, "%c%c%s%c%s%c%c", VY_PRIVATE, VY_PRIVATE_JOIN, from.latin1(), 0, to.latin1(), 0, gender);
}/*}}}*/

void VySendSocket::vy_private_leave(const QHostAddress &addr, const QString &from, const QString &to, char gender)/*{{{*/
{
	send(addr, "%c%c%s%c%s%c%c", VY_PRIVATE, VY_PRIVATE_LEAVE, from.latin1(), 0, to.latin1(), 0, gender);
}/*}}}*/

void VySendSocket::vy_private_say(const QHostAddress &addr, const QString &from, const QString &to, const QString &text)/*{{{*/
{
	send(addr, "%c%c%s%c%s%c%s%c", VY_PRIVATE, VY_PRIVATE_SAY, from.latin1(), 0, to.latin1(), 0, text.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_private_me(const QHostAddress &addr, const QString &from, const QString &to, const QString &text)/*{{{*/
{
	send(addr, "%c%c%s%c%s%c%s%c", VY_PRIVATE, VY_PRIVATE_ME, from.latin1(), 0, to.latin1(), 0, text.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_message(const QHostAddress &addr, const QString &from, const QString &to, const QString &text)/*{{{*/
{
	send(addr, "%c%s%c%s%c%s%c", VY_MESSAGE, from.latin1(), 0, to.latin1(), 0, text.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_massmessage(const QString &from, const QString &to, const QString &text)/*{{{*/
{
	send(broadcast, "%c%s%c%s%c%s%c", VY_MASSMESSAGE, from.latin1(), 0, to.latin1(), 0, text.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_messageack(const QHostAddress &addr, char status, const QString &from, const QString &to, char gender, const QString &answer)/*{{{*/
{
	send(addr, "%c%c%s%c%s%c%c%s%c", VY_MESSAGEACK, status, from.latin1(), 0, to.latin1(), 0, gender, answer.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_herereq(const QString &from, const QString &channel)/*{{{*/
{
	send(broadcast, "%c%s%c%s%c", VY_HEREREQ, from.latin1(), 0, channel.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_hereack(const QHostAddress &addr, const QString &to, const QString &channel, const QString &from, char ra)/*{{{*/
{
	send(addr, "%c%s%c%s%c%s%c", VY_HEREACK, to.latin1(), 0, channel.latin1(), 0, from.latin1(), 0, ra);
}/*}}}*/

void VySendSocket::vy_inforeq(const QHostAddress &addr, const QString &to, const QString &from)/*{{{*/
{
	send(addr, "%c%s%c%s%c", VY_INFOREQ, to.latin1(), 0, from.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_inforeqack(const QHostAddress &addr, const QString &to, const QString &from, const QString &comp,	const QString &name,	const QString &ip, const QString &channels, const QString &answer)/*{{{*/
{
	send(addr, "%c%s%c%s%c%s%c%s%c%s%c%s#%c%s%c", VY_INFOREQACK, to.latin1(), 0, from.latin1(), 0, comp.latin1(), 0,
			name.latin1(), 0, ip.latin1(), 0, channels.latin1(), 0, answer.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_nickchange(const QString &from, const QString &to, char gender)/*{{{*/
{
	send(broadcast, "%c%s%c%s%c%c", VY_NICKCHANGE, from.latin1(), 0, to.latin1(), 0, gender);
}/*}}}*/

void VySendSocket::vy_changestatus(const QString &who, char status, char gender, const QString &answer)/*{{{*/
{
	send(broadcast, "%c%s%c%c%c%s%c", VY_CHANGESTAT, who.latin1(), 0, status, gender, answer.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_newtopic(const QString &channel, const QString &topic, const QString &who)/*{{{*/
{
	send(broadcast, "%c%s%c%s (%s)%c", VY_NEWTOPIC, channel.latin1(), 0, topic.latin1(), who.latin1(), 0);
}/*}}}*/

void VySendSocket::vy_currenttopic(const QHostAddress &addr, const QString &to, const QString &channel, const QString &topic)/*{{{*/
{
	send(addr, "%c%s%c%s%c%s%c", VY_CURRTOPIC, to.latin1(), 0, channel.latin1(), 0, topic.latin1(), 0);
}/*}}}*/

